var tabloc = {
	pref : Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefBranch),
	io : Components.classes['@mozilla.org/network/io-service;1']
		.getService(Components.interfaces.nsIIOService),
	ss : Components.classes["@mozilla.org/browser/sessionstore;1"]
		.getService(Components.interfaces.nsISessionStore),

	init : function() {
		if(!gBrowser){ return; }

		tabloc.addKey("lock_tab_menu",
			tabloc.pref.getCharPref("extensions.tabloc.keymodifiers_lock"),
			tabloc.pref.getCharPref("extensions.tabloc.key_lock"));
		tabloc.addKey("shiftlock_tab_menu",
			tabloc.pref.getCharPref("extensions.tabloc.keymodifiers_shiftlock"),
			tabloc.pref.getCharPref("extensions.tabloc.key_shiftlock"));
		tabloc.addKey("protect_tab_menu",
			tabloc.pref.getCharPref("extensions.tabloc.keymodifiers_protect"),
			tabloc.pref.getCharPref("extensions.tabloc.key_protect"));
		tabloc.addKey("lock_protect_tab_menu",
			tabloc.pref.getCharPref("extensions.tabloc.keymodifiers_lock_protect"),
			tabloc.pref.getCharPref("extensions.tabloc.key_lock_protect"));
		tabloc.addKey("shiftlock_protect_tab_menu",
			tabloc.pref.getCharPref("extensions.tabloc.keymodifiers_shiftlock_protect"),
			tabloc.pref.getCharPref("extensions.tabloc.key_shiftlock_protect"));

		if(tabloc.pref.getBoolPref("extensions.tabloc.add.lock_tab_menu")){
			tabloc.addMenuItem(gBrowser, "lock_tab_menu", 0)
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.add.shiftlock_tab_menu")){
			tabloc.addMenuItem(gBrowser, "shiftlock_tab_menu", 1)
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.add.protect_tab_menu")){
			tabloc.addMenuItem(gBrowser, "protect_tab_menu", 2);
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.add.lock_protect_tab_menu")){
			tabloc.addMenuItem(gBrowser, "lock_protect_tab_menu", 3);
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.add.shiftlock_protect_tab_menu")){
			tabloc.addMenuItem(gBrowser, "shiftlock_protect_tab_menu", 4);
		}

		gBrowser.tabContainer.addEventListener("dblclick", tabloc.dblclick, false);

		gBrowser.tabContainer.addEventListener("mousedown", tabloc.mousedown, false);
		gBrowser.tabContainer.addEventListener("mouseup",   tabloc.mouseup, false);

		gBrowser.tabContainer.addEventListener("SSTabRestored", tabloc.ssTabRestored, false);

		var menuParent = gBrowser.mStrip.firstChild.nextSibling;
		if(menuParent){
			menuParent.addEventListener("popupshowing", tabloc.updateChecked, false);
		}

		gBrowser.ownerDocument.getElementById("appcontent")
			.addEventListener("select", tabloc.updateReloadEnabled, false);

		tabloc.override_removeTab();
	},

	lockTab : function(aTab) {
		if (!aTab || aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
		if (tabloc.isIgnoredTab(aTab)) { return; }

		if (aTab.hasAttribute("__tabloc_locked") && ! aTab.hasAttribute("__tabloc_shiftlock")) {
			aTab.removeAttribute("__tabloc_locked");
			aTab.removeAttribute("__tabloc_shiftlock");
			tabloc.restore_loadURI(gBrowser.getBrowserForTab(aTab));
		} else {
			aTab.setAttribute("__tabloc_locked", "true");
			aTab.removeAttribute("__tabloc_shiftlock");
			tabloc.override_loadURI(gBrowser.getBrowserForTab(aTab), false);
		}
		tabloc.setSession(aTab);
	},

	shiftLockTab : function(aTab) {
		if (!aTab || aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
		if (tabloc.isIgnoredTab(aTab)) { return; }

		if (aTab.hasAttribute("__tabloc_locked") && aTab.hasAttribute("__tabloc_shiftlock"))  {
			aTab.removeAttribute("__tabloc_locked");
			aTab.removeAttribute("__tabloc_shiftlock");
			tabloc.restore_loadURI(gBrowser.getBrowserForTab(aTab));
		} else {
			aTab.setAttribute("__tabloc_locked", "true");
			aTab.setAttribute("__tabloc_shiftlock", "true");
			tabloc.override_loadURI(gBrowser.getBrowserForTab(aTab), true);
		}
		tabloc.setSession(aTab);
	},

	protectTab : function(aTab) {
		if (!aTab || aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
		if (tabloc.isIgnoredTab(aTab)) { return; }

		if (aTab.hasAttribute("__tabloc_protected")) {
			aTab.removeAttribute("__tabloc_protected");
		} else {
			aTab.setAttribute("__tabloc_protected", "true");
		}
		tabloc.setSession(aTab);
	},

	lockProtectTab : function(aTab) {
		if (!aTab || aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
		if (tabloc.isIgnoredTab(aTab)) { return; }

		if (aTab.hasAttribute("__tabloc_locked") && ! aTab.hasAttribute("__tabloc_shiftlock") &&
		    aTab.hasAttribute("__tabloc_protected")) {
			aTab.removeAttribute("__tabloc_locked");
			aTab.removeAttribute("__tabloc_shiftlock");
			aTab.removeAttribute("__tabloc_protected");
			tabloc.restore_loadURI(gBrowser.getBrowserForTab(aTab));
		} else {
			aTab.setAttribute("__tabloc_locked", "true");
			aTab.removeAttribute("__tabloc_shiftlock");
			aTab.setAttribute("__tabloc_protected", "true");
			tabloc.override_loadURI(gBrowser.getBrowserForTab(aTab), false);
		}
		tabloc.setSession(aTab);
	},

	shiftLockProtectTab : function(aTab) {
		if (!aTab || aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
		if (tabloc.isIgnoredTab(aTab)) { return; }

		if (aTab.hasAttribute("__tabloc_locked") && aTab.hasAttribute("__tabloc_shiftlock") &&
		    aTab.hasAttribute("__tabloc_protected")) {
			aTab.removeAttribute("__tabloc_locked");
			aTab.removeAttribute("__tabloc_shiftlock");
			aTab.removeAttribute("__tabloc_protected");
			tabloc.restore_loadURI(gBrowser.getBrowserForTab(aTab));
		} else {
			aTab.setAttribute("__tabloc_locked", "true");
			aTab.setAttribute("__tabloc_shiftlock", "true");
			aTab.setAttribute("__tabloc_protected", "true");
			tabloc.override_loadURI(gBrowser.getBrowserForTab(aTab), true);
		}
		tabloc.setSession(aTab);
	},

	override_removeTab : function(){
		var strRemoveTab = gBrowser.removeTab.toString();
		var pos = strRemoveTab.indexOf('{');
		eval("gBrowser.removeTab = " + strRemoveTab.substr(0, pos+1)
		  + "\nif(!tabloc.canRemoveTab(aTab)) { return; }\n"
		  + strRemoveTab.substr(pos+1));
	},

	override_loadURI : function(browser, fgtab){
		tabloc.restore_loadURI(browser);

		if(fgtab){
			browser.addEventListener("click", tabloc.shiftlock_onclick, true);
		}else{
			browser.addEventListener("click", tabloc.lock_onclick, true);
		}

		if(!browser.__tabloc_loadURI){
			browser.__tabloc_loadURI = browser.loadURI;
			var strLoadURI = browser.loadURI.toString();
			var pos = strLoadURI.indexOf('{');
			eval("browser.loadURI = " + strLoadURI.substr(0, pos+1)
			  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
			  + "  var fgtab = gBrowser.selectedTab.hasAttribute(\"__tabloc_shiftlock\");\n"
			  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, null, !fgtab);\n"
			  + "  return;\n"
			  + "}\n"
			  + strLoadURI.substr(pos+1));
		}
		if(!browser.__tabloc_loadURIWithFlags){
			browser.__tabloc_loadURIWithFlags = browser.loadURIWithFlags;
			var strLoadURIWithFlags = browser.loadURIWithFlags.toString();
			var pos = strLoadURIWithFlags.indexOf('{');
			eval("browser.loadURIWithFlags = " + strLoadURIWithFlags.substr(0, pos+1)
			  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
			  + "  var fgtab = gBrowser.selectedTab.hasAttribute(\"__tabloc_shiftlock\");\n"
			  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, aPostData, !fgtab);\n"
			  + "  return;\n"
			  + "}\n"
			  + strLoadURIWithFlags.substr(pos+1));
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.prevent_back_forward")){
			if(!browser.__tabloc_goBack){
				browser.__tabloc_goBack = browser.goBack;
				browser.goBack = tabloc.do_nothing;
			}
			if(!browser.__tabloc_goForward){
				browser.__tabloc_goForward = browser.goForward;
				browser.goForward = tabloc.do_nothing;
			}
		}
		if(tabloc.pref.getBoolPref("extensions.tabloc.prevent_reload")){
			if(!browser.__tabloc_reload){
				browser.__tabloc_reload = browser.reload;
				browser.reload = tabloc.do_nothing;
			}
			if(!browser.__tabloc_reloadWithFlags){
				browser.__tabloc_reloadWithFlags = browser.reloadWithFlags;
				browser.reloadWithFlags = tabloc.do_nothing;
			}
			tabloc.updateReloadEnabled();
		}
	},

	do_nothing : function(){
		return;
	},

	updateReloadEnabled : function(){
		var aTab = gBrowser.selectedTab;
		var browser = gBrowser.getBrowserForTab(aTab);
		if(browser.__tabloc_reload) {
			tabloc.setDisabled("Browser:Reload", "true");
			tabloc.setDisabled("Browser:ReloadOrDuplicate", "true");
		}
	},

	setDisabled : function(id, value) {
		var item = gBrowser.ownerDocument.getElementById(id);
		if(item == null){ return; }
		if(value){
			item.setAttribute("disabled", value);
		}else{
			item.removeAttribute("disabled");
		}
	},

	restore_loadURI : function(browser){
		try{
			if(browser.__tabloc_loadURI){
				browser.loadURI = browser.__tabloc_loadURI;
				delete browser.__tabloc_loadURI;
			}
			if(browser.__tabloc_loadURIWithFlags){
				browser.loadURIWithFlags = browser.__tabloc_loadURIWithFlags;
				delete browser.__tabloc_loadURIWithFlags;
			}
			if(browser.__tabloc_goBack){
				browser.goBack = browser.__tabloc_goBack;
				delete browser.__tabloc_goBack;
			}
			if(browser.__tabloc_goForward){
				browser.goForward = browser.__tabloc_goForward;
				delete browser.__tabloc_goForward;
			}
			if(browser.__tabloc_reload){
				browser.reload = browser.__tabloc_reload;
				delete browser.__tabloc_reload;
			}
			if(browser.__tabloc_reloadWithFlags){
				browser.reloadWithFlags = browser.__tabloc_reloadWithFlags;
				delete browser.__tabloc_reloadWithFlags;
			}
			browser.removeEventListener("click", tabloc.lock_onclick, true);
			browser.removeEventListener("click", tabloc.shiftlock_onclick, true);
			tabloc.setDisabled("Browser:Reload", false);
			tabloc.setDisabled("Browser:ReloadOrDuplicate", false);
		}catch(e){}
	},

	isIgnoredTab : function(aTab){
		try{
			if (tabloc.pref.getBoolPref("extensions.tabloc.ex_aboutblank")) {
				var url = gBrowser.getBrowserForTab(aTab).currentURI.spec;
				if(url == "" || url == "about:blank"){
					return true;
				}
			}
		}catch(e){ }
		return false;
	},

	canRemoveTab : function(aTab){
		try{
			if(gBrowser.selectedTab == aTab && 
				tabloc.pref.getBoolPref("extensions.tabloc.close_active") &&
					! aTab.mOverCloseButton){
				return true;
			}
			if(aTab.hasAttribute("__tabloc_protected")){
				return false;
			}
		}catch(e){ }
		return true;
	},

	lock_onclick : function(evt){
		tabloc.onclick(evt, false);
	},

	shiftlock_onclick : function(evt){
		tabloc.onclick(evt, true);
	},

	onclick : function(evt, fgtab){
		if(evt && evt.target && evt.button == 0){
			var a = evt.target;
			while(a && !a.href && a.tagName && (a.tagName.toLowerCase() != "form")){
				a = a.parentNode;
			}

			if(a && a.href){
				tabloc.href(a, evt, fgtab);
			}else if(a && a.tagName && a.tagName.toLowerCase() === "form"){
				tabloc.form(a, evt);
			}
		}
	},

	href : function(a, evt, fgtab) {
		if(!gBrowser){ return; }
		var exinpage     = tabloc.pref.getBoolPref("extensions.tabloc.ex_inpagelink");
		var exjavascript = tabloc.pref.getBoolPref("extensions.tabloc.ex_javascript");
		var currentURL   = a.ownerDocument.URL;

		if(exinpage){
			var targethref = tabloc.getTargetURL(a).split("#")[0];
			if(a.href === targethref || a.href.indexOf(targethref + "#") == 0){
				return;
			}
		}
		if(exjavascript){
			if(a.href.indexOf("javascript:") == 0){
				return;
			}
		}

		// works with Tree Style Tab ( https://addons.mozilla.org/firefox/5890 )
		if ('TreeStyleTabService' in window) {
			TreeStyleTabService.readyToOpenChildTab(gBrowser.selectedTab);
		}
	
		var sendref = tabloc.pref.getBoolPref("extensions.tabloc.send_referer");
		if(sendref){
			var referer = tabloc.io.newURI(currentURL, null, null);
			gBrowser.loadOneTab(a.href, referer, null, null, !fgtab);
		}else{
			gBrowser.loadOneTab(a.href, null, null, null, !fgtab);
		}

		evt.stopPropagation();
		evt.preventDefault();
	},

	getTargetURL : function(a) {
		var target = a.target;
		if(target == null || target == "" || target == "_self"){
			return a.ownerDocument.URL;
		}else if(target == "_blank"){
			return "";
		}else if(target == "_top"){
			return gBrowser.currentURI.spec;
		}else{
			var frames = gBrowser.contentWindow.frames;
			for(var i=0; i<frames.length; i++){
				if(frames[i].name == target){
					return frames[i].document.location.href;
				}
			}
		}
		return a.ownerDocument.URL;
	},

	form : function(a, evt) {
		var exform = tabloc.pref.getBoolPref("extensions.tabloc.ex_formsubmit");
		if(exform){
			return;
		}
		a.setAttribute("__tabloc_target", a.target);
		a.target = "_blank";
		a.ownerDocument.defaultView.setTimeout(tabloc.restore_target, 500, a);
	},

	restore_target : function(a){
		if(a.hasAttribute("__tabloc_target")){
			a.target = a.getAttribute("__tabloc_target");
			a.removeAttribute("__tabloc_target");
		}
	},

	addKey : function(menuid, modifiers, keycode) {
		var key = document.getElementById("key_" + menuid);
		if(keycode.length == 1){
			key.setAttribute("modifiers", modifiers);
			key.setAttribute("key", keycode);
			key.setAttribute("disabled", false);
		}else if(keycode.length > 1){
			key.setAttribute("modifiers", modifiers);
			key.setAttribute("keycode", "VK_" + keycode);
			key.setAttribute("disabled", false);
		}
	},

	addMenuItem : function(contentBrowser, menuid, menuindex) {
		var newMenu = document.getElementById(menuid).cloneNode(false);
		if(!newMenu){ return null; }
		newMenu.id = "tab-" + menuid;
		var menuParent = contentBrowser.mStrip.firstChild.nextSibling;
		var pos = tabloc.pref.getIntPref("extensions.tabloc.menu_pos") + menuindex;
		if(pos >= menuParent.childNodes.length){
			menuParent.appendChild(newMenu);
		}else{
			menuParent.insertBefore(newMenu, menuParent.childNodes[pos]);
		}
		return newMenu;
	},

	dblclick : function(evt){
		if(evt.button != 0){ return; }
		switch(tabloc.pref.getIntPref("extensions.tabloc.dblclick_action")){
			case 1: tabloc.lockTab(null); break;
			case 5: tabloc.shiftLockTab(null); break;
			case 2: tabloc.protectTab(null); break;
			case 3: tabloc.lockProtectTab(null); break;
			case 7: tabloc.shiftLockProtectTab(null); break;
			default: break;
		}
	},

	mousedown_browser : null,
	mousedown : function(evt){
		if(evt.button != 0){ return; }
		if(!gBrowser){ return; }
		tabloc.mousedown_browser = gBrowser.selectedBrowser;
		var time = tabloc.pref.getIntPref("extensions.tabloc.longpush_time");
		tabloc.mousedown_browser.__tabloc_timer = tabloc.mousedown_browser.contentWindow.setTimeout(tabloc.longpush, time);
		if(gBrowser.selectedTab){
			gBrowser.selectedTab.addEventListener("dragexit", tabloc.mouseup, false);
		}
	},

	mouseup : function(){
		if(gBrowser && gBrowser.selectedTab){
			gBrowser.selectedTab.removeEventListener("dragexit", tabloc.mouseup, false);
		}
		if(tabloc.mousedown_browser != null){
			tabloc.mousedown_browser.contentWindow.clearTimeout(tabloc.mousedown_browser.__tabloc_timer);
			delete tabloc.mousedown_browser.__tabloc_timer;
		}
	},

	longpush : function(){
		switch(tabloc.pref.getIntPref("extensions.tabloc.longpush_action")){
			case 1: tabloc.lockTab(null); break;
			case 5: tabloc.shiftLockTab(null); break;
			case 2: tabloc.protectTab(null); break;
			case 3: tabloc.lockProtectTab(null); break;
			case 7: tabloc.shiftLockProtectTab(null); break;
			default: break;
		}
	},

	setChecked : function(id, value) {
		var item = gBrowser.ownerDocument.getElementById(id);
		if(item == null){ return; }
		if(value){
			item.setAttribute("checked", true);
		}else{
			item.removeAttribute("checked");
		}
	},

	setVisible : function(id, value) {
		var item = gBrowser.ownerDocument.getElementById(id);
		if(item == null){ return; }
		var style = item.getAttribute("style");
		if(value){
			item.setAttribute("style", style.replace("display: none;",""));
		}else{
			item.setAttribute("style", "display: none;" + style);
		}
	},

	updateChecked : function() {
		var aTab = gBrowser.mContextTab;
		if(!aTab){ return; }
		if(tabloc.isIgnoredTab(aTab)){
			tabloc.setVisible("tab-lock_tab_menu", false);
			tabloc.setVisible("tab-shiftlock_tab_menu", false);
			tabloc.setVisible("tab-protect_tab_menu", false);
			tabloc.setVisible("tab-lock_protect_tab_menu", false);
			tabloc.setVisible("tab-shiftlock_protect_tab_menu", false);
			return;
		}
		var l = aTab.hasAttribute("__tabloc_locked");
		var s = aTab.hasAttribute("__tabloc_shiftlock");
		var p = aTab.hasAttribute("__tabloc_protected");

		tabloc.setChecked("tab-lock_tab_menu", l && !s);
		tabloc.setChecked("tab-shiftlock_tab_menu", l && s);
		tabloc.setChecked("tab-protect_tab_menu", p);
		tabloc.setChecked("tab-lock_protect_tab_menu", l && !s && p);
		tabloc.setChecked("tab-shiftlock_protect_tab_menu", l && s && p);

		tabloc.setVisible("tab-lock_tab_menu", true);
		tabloc.setVisible("tab-shiftlock_tab_menu", true);
		tabloc.setVisible("tab-protect_tab_menu", true);
		tabloc.setVisible("tab-lock_protect_tab_menu", true);
		tabloc.setVisible("tab-shiftlock_protect_tab_menu", true);
	},

	setSession : function(aTab) {
		var l = (aTab.hasAttribute("__tabloc_locked")    ? 1 : 0);
		var p = (aTab.hasAttribute("__tabloc_protected") ? 2 : 0);
		var s = (aTab.hasAttribute("__tabloc_shiftlock") ? 4 : 0);
		tabloc.ss.setTabValue(aTab, "tabloc.locked", l + p + s);
	},

	ssTabRestored : function(evt) {
		var aTab = evt.target;
		var value = tabloc.ss.getTabValue(aTab, "tabloc.locked") - 0;
		switch(value){
			case 1: tabloc.lockTab(aTab); break;
			case 5: tabloc.shiftLockTab(aTab); break;
			case 2: tabloc.protectTab(aTab); break;
			case 3: tabloc.lockProtectTab(aTab); break;
			case 7: tabloc.shiftLockProtectTab(aTab); break;
			default: break;
		}
	},

	close : function() {
		var resume_session = tabloc.pref.getBoolPref("extensions.tabloc.resume_session");
		var close_unprotected = tabloc.pref.getBoolPref("extensions.tabloc.resume_session.close_unprotected");
		if(resume_session && close_unprotected){
			var tabs = gBrowser.tabContainer.childNodes;
			for(var i=0; i<tabs.length; i++){
				if(tabs[i].hasAttribute("__tabloc_protected")){
					gBrowser.removeAllTabsBut(tabs[i]);
					return;
				}
			}
		}
	},

	unload : function() {
		var resume_session = tabloc.pref.getBoolPref("extensions.tabloc.resume_session");
		if(resume_session){
			var tabs = gBrowser.tabContainer.childNodes;
			for(var i=0; i<tabs.length; i++){
				if(tabs[i].hasAttribute("__tabloc_protected")){
					tabloc.pref.setBoolPref("browser.sessionstore.resume_session_once", true);
					return;
				}
			}
		}
	}
}
